#include "jbsql.h"

void ExportCSVData(TextWidget *text,char *filename)
{
  int x,do_it=1,bufsize=0;
  char *buffer;
  HANDLE of;
	DWORD bytes_read,bytes_written;
  HCURSOR c;

  of=CreateFile(filename,
             GENERIC_WRITE,
             FILE_SHARE_READ,
             NULL,
             CREATE_ALWAYS,
             0,
             NULL);
             
  if (of==INVALID_HANDLE_VALUE)
  {
    DisplayLastError(NULL);
    return;
  }
	SetFilePointer(f,0,0,FILE_BEGIN);
	for (x=0;x<ncols;x++)
	{
		recordlength+=cols[x].col_size;
    if (cols[x].col_size>bufsize)
			bufsize=cols[x].col_size;
    if (x)
      WriteFile(of,";",1,&bytes_written,NULL);
    WriteFile(of,cols[x].col_name,strlen(cols[x].col_name),&bytes_written,NULL);
	}
  WriteFile(of,"\r\n",2,&bytes_written,NULL);
	if (bufsize)
    buffer=(char*)malloc(bufsize*2+1);
	else
		return;
  if (buffer==NULL)
  {
    Error(NULL,"Out of memory");
    return;
  }
  c=SetCursor(LoadCursor(NULL, IDC_WAIT));
  while (do_it)
  {
    for (x=0;x<ncols;x++)
    {
  	  ReadFile(f,buffer,cols[x].col_size,&bytes_read,NULL);
      if (bytes_read==0)
      {
        do_it=0;
        break;
      }
      buffer[bytes_read]='\0';
      if (x)
        WriteFile(of,";\"",2,&bytes_written,NULL);
      else
        WriteFile(of,"\"",1,&bytes_written,NULL);
      ReplaceString(buffer,"\"","\"\"");
      WriteFile(of,buffer,strlen(buffer),&bytes_written,NULL);
      WriteFile(of,"\"",1,&bytes_written,NULL);
    }
    WriteFile(of,"\r\n",2,&bytes_written,NULL);
  }
  CloseHandle(of);
  free(buffer);
  SetCursor(c);
}

void ExportSQLData(TextWidget *text,char *filename)
{
  int x,y,do_it=1,bufsize=0;
  char *buffer,str[200],date_format[100];
  HANDLE of;
	DWORD bytes_read,bytes_written;
  HCURSOR c;

  of=CreateFile(filename,
             GENERIC_WRITE,
             FILE_SHARE_READ,
             NULL,
             CREATE_ALWAYS,
             0,
             NULL);
             
  if (of==INVALID_HANDLE_VALUE)
  {
    DisplayLastError(NULL);
    return;
  }
	SetFilePointer(f,0,0,FILE_BEGIN);
	for (x=0;x<ncols;x++)
	{
		recordlength+=cols[x].col_size;
    if (cols[x].col_size>bufsize)
			bufsize=cols[x].col_size;
	}
	if (bufsize)
    buffer=(char*)malloc(bufsize*2+1);
	else
		return;
  if (buffer==NULL)
  {
    Error(NULL,"Out of memory");
    return;
  }
  strcpy(str,"set scan off\r\n");
  c=SetCursor(LoadCursor(NULL, IDC_WAIT));
  if (GetSingleValue("select sys_context('userenv','nls_date_format') from dual",date_format,100)!=0)
    date_format[0]='\0';
  WriteFile(of,str,strlen(str),&bytes_written,NULL);
  while (do_it)
  {
    for (x=0;x<ncols;x++)
    {
  	  ReadFile(f,buffer,cols[x].col_size,&bytes_read,NULL);
      if (bytes_read==0)
      {
        do_it=0;
        break;
      }
      if (x)
        WriteFile(of,",",1,&bytes_written,NULL);
      else
      {
        strcpy(str,"insert into (");
        WriteFile(of,str,strlen(str),&bytes_written,NULL);
        WriteFile(of,old_commands[nold_commands-1].command,strlen(old_commands[nold_commands-1].command),&bytes_written,NULL);
        strcpy(str,")\r\n(");
        WriteFile(of,str,strlen(str),&bytes_written,NULL);
        for (y=0;y<ncols;y++)
        {
          if (y)
            WriteFile(of,",\"",2,&bytes_written,NULL);
          else
            WriteFile(of,"\"",1,&bytes_written,NULL);
          WriteFile(of,cols[y].col_name,strlen(cols[y].col_name),&bytes_written,NULL);
          WriteFile(of,"\"",1,&bytes_written,NULL);
        }
        strcpy(str,")\r\nvalues\r\n(");
        WriteFile(of,str,strlen(str),&bytes_written,NULL);
      }
      buffer[bytes_read]='\0';
      switch (cols[x].datatype)
      {
        case OCI_TYPECODE_REAL:
        case OCI_TYPECODE_DOUBLE:
        case OCI_TYPECODE_FLOAT:
        case OCI_TYPECODE_NUMBER:
        case OCI_TYPECODE_DECIMAL:
        case OCI_TYPECODE_OCTET:
        case OCI_TYPECODE_INTEGER:
        case OCI_TYPECODE_SMALLINT:
          if (buffer[0]!='\0')
            WriteFile(of,buffer,strlen(buffer),&bytes_written,NULL);
          else
          {
            strcpy(str,"NULL");
            WriteFile(of,str,strlen(str),&bytes_written,NULL);
          }
          break;
        case OCI_TYPECODE_RAW:
        case OCI_TYPECODE_VARCHAR2:
        case OCI_TYPECODE_VARCHAR:
        case OCI_TYPECODE_CHAR:
        case OCI_TYPECODE_CLOB:
        case OCI_TYPECODE_BLOB:
        case OCI_TYPECODE_BFILE:
        case SQLT_LNG:
        case SQLT_BIN:
        case SQLT_LBI:
        case SQLT_RID:
        case SQLT_RDD:
          if (buffer[0]!='\0')
          {
            ReplaceString(buffer,"'","''");
            WriteFile(of,"'",1,&bytes_written,NULL);
            WriteFile(of,buffer,strlen(buffer),&bytes_written,NULL);
            WriteFile(of,"'",1,&bytes_written,NULL);
          }
          else
          {
            strcpy(str,"NULL");
            WriteFile(of,str,strlen(str),&bytes_written,NULL);
          }
          break;
        case OCI_TYPECODE_DATE:
          if (buffer[0]!='\0')
          {
            if (date_format[0])
            {
              sprintf(str,"to_date('%s','%s')",buffer,date_format);
              WriteFile(of,str,strlen(str),&bytes_written,NULL);
            }
            else
            {
              WriteFile(of,"'",1,&bytes_written,NULL);
              WriteFile(of,buffer,strlen(buffer),&bytes_written,NULL);
              WriteFile(of,"'",1,&bytes_written,NULL);
            }
          }
          else
          {
            strcpy(str,"NULL");
            WriteFile(of,str,strlen(str),&bytes_written,NULL);
          }
          break;
      }
    }
    if (do_it)
    {
      strcpy(str,")\r\n/\r\n");
      WriteFile(of,str,strlen(str),&bytes_written,NULL);
    }
  }
  CloseHandle(of);
  free(buffer);
  SetCursor(c);
}

void ExportXMLData(TextWidget *text,char *filename)
{
  int x,do_it=1,bufsize=0,row=0;
  char *buffer;
  HANDLE of;
	DWORD bytes_read,bytes_written;
  HCURSOR c;
  char str[200],col_name[100];

  of=CreateFile(filename,
             GENERIC_WRITE,
             FILE_SHARE_READ,
             NULL,
             CREATE_ALWAYS,
             0,
             NULL);
             
  if (of==INVALID_HANDLE_VALUE)
  {
    DisplayLastError(NULL);
    return;
  }
	SetFilePointer(f,0,0,FILE_BEGIN);
	for (x=0;x<ncols;x++)
	{
		recordlength+=cols[x].col_size;
    if (cols[x].col_size>bufsize)
			bufsize=cols[x].col_size;
	}
	if (bufsize)
    buffer=(char*)malloc(bufsize*2+1);
	else
		return;
  if (buffer==NULL)
  {
    Error(NULL,"Out of memory");
    return;
  }
  c=SetCursor(LoadCursor(NULL, IDC_WAIT));
  strcpy(str,"<?xml version=\"1.0\" encoding=\"UTF-8\"?>\r\n");
  WriteFile(of,str,strlen(str),&bytes_written,NULL);
  strcpy(str,"<ROWS>\r\n");
  WriteFile(of,str,strlen(str),&bytes_written,NULL);
  while (do_it)
  {
    row++;
    for (x=0;x<ncols;x++)
    {
  	  ReadFile(f,buffer,cols[x].col_size,&bytes_read,NULL);
      if (bytes_read==0)
      {
        do_it=0;
        break;
      }
      buffer[bytes_read]='\0';
      ReplaceString(buffer,"<","&lt");
      ReplaceString(buffer,">","&gt");
      ReplaceString(buffer,"'","&amp");
      if (x==0)
      {
        sprintf(str,"  <ROW num=\"%d\">\r\n",row);
        WriteFile(of,str,strlen(str),&bytes_written,NULL);
      }
      strcpy(col_name,cols[x].col_name);
      ReplaceString(col_name," ","_");
      sprintf(str,"    <%s>%s</%s>\r\n",col_name,buffer,col_name);
      WriteFile(of,str,strlen(str),&bytes_written,NULL);
    }
    if (do_it)
    {
      strcpy(str,"  </ROW>\r\n");
      WriteFile(of,str,strlen(str),&bytes_written,NULL);
    }
  }
  strcpy(str,"</ROWS>\r\n");
  WriteFile(of,str,strlen(str),&bytes_written,NULL);
  CloseHandle(of);
  free(buffer);
  SetCursor(c);
}

void ExportData(TextWidget *text)
{
  OPENFILENAME openFile;
  char filename[MAX_PATH]="\0";
  char filter[200]="Comma Separated Value Files (*.csv, *.txt))\0*.CSV;*.TXT\0XML Files (*.xml)\0*.xml\0SQL Scripts (*.sql)\0*.sql\0\0\0";
  char extentions[][5]={".csv",".xml",".sql"};
  char *pos1,*pos2;

  if (f==NULL)
  {
    Error(NULL,"No data to export");
    return;
  }

  openFile.lStructSize=sizeof(OPENFILENAME);
  openFile.hwndOwner=g_hWnd;
  openFile.hInstance=NULL;
  openFile.lpstrFilter=filter;
  openFile.lpstrCustomFilter=NULL;
  openFile.nMaxCustFilter=255;
  openFile.nFilterIndex=0;
  openFile.lpstrFile=filename;
  openFile.nMaxFile=MAX_PATH;
  openFile.lpstrFileTitle=NULL;
  openFile.nMaxFileTitle=0;
  openFile.lpstrInitialDir=NULL;
  openFile.lpstrTitle=NULL;
  openFile.Flags=OFN_OVERWRITEPROMPT;
  openFile.nFileOffset=0;
  openFile.nFileExtension=0;
  openFile.lpstrDefExt=NULL;
  openFile.lCustData=0;
  openFile.lpfnHook=NULL;
  openFile.lpTemplateName=NULL;
  GetSaveFileName(&openFile);
  if (filename[0]=='\0')
    return;
  pos1=strrchr(filename,'.');
  pos2=strrchr(filename,'\\');
  if (pos1==NULL)
    strcat(filename,extentions[openFile.nFilterIndex-1]);
  else
  {
    if (pos2!=NULL && pos2>pos1)
      strcat(filename,extentions[openFile.nFilterIndex-1]);
  }
  switch (openFile.nFilterIndex)
  {
    case 1:
      ExportCSVData(text,filename);
      break;
    case 2:
      ExportXMLData(text,filename);
      break;
    case 3:
      ExportSQLData(text,filename);
      break;
  }
}

void CopyFromListView(HWND hWnd,int entire_line)
{
  int x,y,nlines=0,nselected=0,found=0,recordsize=0,fieldsize=0;
  DWORD bytes_read;
  char *buffer,*field,*newclipstr,*lockedclipstr;
  HCURSOR c;

  nlines=ListView_GetItemCount(hWnd);
  nselected=ListView_GetSelectedCount(hWnd);
  if (!nlines || !nselected)
    return;
  for (x=0;x<ncols;x++)
  {
    recordsize+=cols[x].col_size;
    if (cols[x].col_size>fieldsize)
      fieldsize=cols[x].col_size;
  };
  buffer=malloc((recordsize+ncols+3)*nselected);
  if (buffer==NULL)
  {
    Error(NULL,"Out of memory");
    return;
  }
  field=malloc(fieldsize+1);
  if (field==NULL)
  {
    Error(NULL,"Out of memory");
    return;
  }
  c=SetCursor(LoadCursor(NULL, IDC_WAIT));
  buffer[0]='\0';
  for (x=0;x<nlines && found<nselected;x++)
  {
    if (ListView_GetItemState(hWnd,x,LVIS_SELECTED)&LVIS_SELECTED)
    {
      if (found)
        strcat(buffer,"\r\n");
      if (entire_line)
      {
  	    SetFilePointer(f,recordlength*x,0,FILE_BEGIN);
        for (y=0;y<ncols;y++)
        {
			    ReadFile(f,field,cols[y].col_size,&bytes_read,NULL);
          field[bytes_read]='\0';
          if (y)
            strcat(buffer," ");
          strcat(buffer,field);
        }
      }
      else
      {
			  SetFilePointer(f,recordlength*x,0,FILE_BEGIN);
			  ReadFile(f,field,cols[0].col_size,&bytes_read,NULL);
        field[bytes_read]='\0';
        strcat(buffer,field);
      }
      found++;
    }
  }
  if (OpenClipboard(hWnd))
  {
    EmptyClipboard();
    newclipstr=GlobalAlloc(GMEM_DDESHARE,strlen(buffer)+1);
    if (newclipstr!=NULL)
    {
      lockedclipstr=GlobalLock(newclipstr);
      if (lockedclipstr!=NULL)
      {
        strcpy(lockedclipstr,buffer);
        GlobalUnlock(newclipstr);
        if (SetClipboardData(CF_TEXT, newclipstr)==NULL)
          DisplayLastError(NULL);
      }
    }
    CloseClipboard();
  }
  free(buffer);
  SetCursor(c);
}
