#include "jboci.h"

int ProcessSynonym(HWND hWnd,char *schema,char *synonym)
{
  char *tablestr="select TABLE_OWNER,TABLE_NAME,DB_LINK from all_synonyms where owner=:p_schema and synonym_name=:p_synonym";
  char table_owner[31],table_name[31]="",db_link[129]="";
  ub2 table_owner_i=-1,db_link_i=-1,table_name_i=-1;
  OCIBind *bndhp=NULL;
  OCIDefine *defhp=NULL;
  OCIStmt *stmtp=NULL;

  if (ChkOCIErrS(OCIHandleAlloc(g_oci->envhp, 
                               (dvoid**)&stmtp,
                               OCI_HTYPE_STMT, 
                               0, 
                               NULL)))
  {
    return -1;
  }
  if (ChkOCIErrS(OCIStmtPrepare(stmtp,
                               g_oci->errhp,
                               tablestr,
                               strlen(tablestr),
                               OCI_NTV_SYNTAX,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }
  if (ChkOCIErrS(OCIBindByName(stmtp,
                             &bndhp,
                             g_oci->errhp,
                             "p_schema",
                             strlen("p_schema"),
                             schema,
                             strlen(schema)+1,
                             SQLT_STR,
                             NULL,
                             NULL,
                             NULL,
                             0,
                             NULL,
                             OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    return -1;
  }
  if (ChkOCIErrS(OCIBindByName(stmtp,
                             &bndhp,
                             g_oci->errhp,
                             "p_synonym",
                             strlen("p_synonym"),
                             synonym,
                             strlen(synonym)+1,
                             SQLT_STR,
                             NULL,
                             NULL,
                             NULL,
                             0,
                             NULL,
                             OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    return -1;
  }
  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               1,
                               table_owner,
                               sizeof(table_owner),
                               SQLT_STR,
                               &table_owner_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               2,
                               table_name,
                               sizeof(table_name),
                               SQLT_STR,
                               &table_name_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }
  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               3,
                               db_link,
                               sizeof(db_link),
                               SQLT_STR,
                               &db_link_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }


  if (ChkOCIErrS(OCIStmtExecute(g_oci->svchp,
                        stmtp,
                        g_oci->errhp,
                        0,
                        0,
                        NULL,
                        NULL,
                        OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }
  if (ChkOCIErrS(OCIStmtFetch(stmtp,
                      g_oci->errhp,
                      1,
                      OCI_FETCH_NEXT,
                      OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }
  OCIHandleFree(stmtp,OCI_HTYPE_STMT);
  stmtp=NULL;
  if (!strcmp(schema,"PUBLIC"))
    SchemaPrintf(hWnd,"CREATE PUBLIC SYNONYM \"%s\" FOR ",synonym);
  else
    SchemaPrintf(hWnd,"CREATE SYNONYM \"%s\" FOR ",synonym);
  if (table_owner_i!=(ub2)-1)
    SchemaPrintf(hWnd," \"%s\".",table_owner);
  SchemaPrintf(hWnd,"\"%s\"",table_name);
  if (db_link_i!=(ub2)-1)
    SchemaPrintf(hWnd,"@\"%s\"",db_link);
  SchemaPrintf(hWnd,"\n/\n\n");
  return 0;
}

