#include "jboci.h"

int ProcessViewColumns(HWND hWnd,char *schema,char *view)
{
  OCIBind *bndhp=NULL;
  OCIDefine *defhp=NULL;
  OCIStmt *stmtp=NULL;
  char *columnstr="select column_name from all_tab_columns where owner=:p_schema and table_name=:p_view order by column_id";
  char column_name[31]="";
  ub2 column_name_i;
  int n,result;

  if (ChkOCIErrS(OCIHandleAlloc(g_oci->envhp, 
                               (dvoid**)&stmtp,
                               OCI_HTYPE_STMT, 
                               0, 
                               NULL)))
  {
    return -1;
  }
  if (ChkOCIErrS(OCIStmtPrepare(stmtp,
                               g_oci->errhp,
                               columnstr,
                               strlen(columnstr),
                               OCI_NTV_SYNTAX,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }
  if (ChkOCIErrS(OCIBindByName(stmtp,
                             &bndhp,
                             g_oci->errhp,
                             "p_schema",
                             strlen("p_schema"),
                             schema,
                             strlen(schema)+1,
                             SQLT_STR,
                             NULL,
                             NULL,
                             NULL,
                             0,
                             NULL,
                             OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    return -1;
  }
  if (ChkOCIErrS(OCIBindByName(stmtp,
                             &bndhp,
                             g_oci->errhp,
                             "p_view",
                             strlen("p_view"),
                             view,
                             strlen(view)+1,
                             SQLT_STR,
                             NULL,
                             NULL,
                             NULL,
                             0,
                             NULL,
                             OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    return -1;
  }
  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               1,
                               column_name,
                               sizeof(column_name),
                               SQLT_STR,
                               &column_name_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIStmtExecute(g_oci->svchp,
                        stmtp,
                        g_oci->errhp,
                        0,
                        0,
                        NULL,
                        NULL,
                        OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  n=0;
  for (;;)
  {
    result=OCIStmtFetch(stmtp,
                        g_oci->errhp,
                        1,
                        OCI_FETCH_NEXT,
                        OCI_DEFAULT);
    if (result!=OCI_SUCCESS && result!=OCI_NO_DATA && result!=OCI_SUCCESS_WITH_INFO)
    {
      break;
    }
    if (result==OCI_NO_DATA)
      break;
    if (n)
      SchemaPrintf(hWnd,",\"%s\"",column_name);
    else
      SchemaPrintf(hWnd,"\"%s\"",column_name);
    n++;
  }
  OCIHandleFree(stmtp,OCI_HTYPE_STMT);
  stmtp=NULL;
  return 0;
}


int ProcessView(HWND hWnd,char *schema,char *view)
{
  OCIBind *bndhp=NULL;
  OCIDefine *defhp=NULL;
  OCIStmt *stmtp=NULL;
  char *viewstr1="select TEXT_LENGTH from all_views where owner=:p_schema and view_name=:p_view";
  char *viewstr2="select TEXT from all_views where owner=:p_schema and view_name=:p_view";
  char *text=NULL;
  unsigned text_length;
  ub2 text_length_i,text_i;

  if (ChkOCIErrS(OCIHandleAlloc(g_oci->envhp, 
                               (dvoid**)&stmtp,
                               OCI_HTYPE_STMT, 
                               0, 
                               NULL)))
  {
    return -1;
  }
  if (ChkOCIErrS(OCIStmtPrepare(stmtp,
                               g_oci->errhp,
                               viewstr1,
                               strlen(viewstr1),
                               OCI_NTV_SYNTAX,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }
  if (ChkOCIErrS(OCIBindByName(stmtp,
                             &bndhp,
                             g_oci->errhp,
                             "p_schema",
                             strlen("p_schema"),
                             schema,
                             strlen(schema)+1,
                             SQLT_STR,
                             NULL,
                             NULL,
                             NULL,
                             0,
                             NULL,
                             OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    return -1;
  }
  if (ChkOCIErrS(OCIBindByName(stmtp,
                             &bndhp,
                             g_oci->errhp,
                             "p_view",
                             strlen("p_view"),
                             view,
                             strlen(view)+1,
                             SQLT_STR,
                             NULL,
                             NULL,
                             NULL,
                             0,
                             NULL,
                             OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    return -1;
  }
  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               1,
                               &text_length,
                               sizeof(text_length),
                               SQLT_UIN,
                               &text_length_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIStmtExecute(g_oci->svchp,
                        stmtp,
                        g_oci->errhp,
                        0,
                        0,
                        NULL,
                        NULL,
                        OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIStmtFetch(stmtp,
                      g_oci->errhp,
                      1,
                      OCI_FETCH_NEXT,
                      OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }
  OCIHandleFree(stmtp,OCI_HTYPE_STMT);
  stmtp=NULL;
  
  text=(char*)malloc(text_length+1);

  if (ChkOCIErrS(OCIHandleAlloc(g_oci->envhp, 
                               (dvoid**)&stmtp,
                               OCI_HTYPE_STMT, 
                               0, 
                               NULL)))
  {
    return -1;
  }
  if (ChkOCIErrS(OCIStmtPrepare(stmtp,
                               g_oci->errhp,
                               viewstr2,
                               strlen(viewstr2),
                               OCI_NTV_SYNTAX,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }
  if (ChkOCIErrS(OCIBindByName(stmtp,
                             &bndhp,
                             g_oci->errhp,
                             "p_schema",
                             strlen("p_schema"),
                             schema,
                             strlen(schema)+1,
                             SQLT_STR,
                             NULL,
                             NULL,
                             NULL,
                             0,
                             NULL,
                             OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    return -1;
  }
  if (ChkOCIErrS(OCIBindByName(stmtp,
                             &bndhp,
                             g_oci->errhp,
                             "p_view",
                             strlen("p_view"),
                             view,
                             strlen(view)+1,
                             SQLT_STR,
                             NULL,
                             NULL,
                             NULL,
                             0,
                             NULL,
                             OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    return -1;
  }
  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               1,
                               text,
                               text_length+1,
                               SQLT_STR,
                               &text_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIStmtExecute(g_oci->svchp,
                        stmtp,
                        g_oci->errhp,
                        0,
                        0,
                        NULL,
                        NULL,
                        OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIStmtFetch(stmtp,
                      g_oci->errhp,
                      1,
                      OCI_FETCH_NEXT,
                      OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }
  OCIHandleFree(stmtp,OCI_HTYPE_STMT);
  stmtp=NULL;

  SchemaPrintf(hWnd,"CREATE OR REPLACE FORCE VIEW \"%s\"\n(",view);
  ProcessViewColumns(hWnd,schema,view);
  SchemaPrintf(hWnd,")\nAS\n%s\n/\n",text);
  SchemaPrintf(hWnd,"show err\n");

  free(text);
  return 0;
}

