#include "jbsql.h"

void WriteRegistryString(char *key,char *subkey,char *value)
{
  HKEY hk;
  DWORD dp;
  int sz;

  sz=strlen(value)+1;
  if (RegCreateKeyEx(
      HKEY_CURRENT_USER,
      key,
      0,
      "REG_SZ",
      REG_OPTION_NON_VOLATILE,
      KEY_WRITE,
      NULL,
      &hk,
      &dp)!=ERROR_SUCCESS)
    return;
  RegSetValueEx(hk,subkey,0,REG_SZ,value,sz);
  RegCloseKey(hk);
}

void WriteRegistryBytes(char *key,char *subkey,void *value,int sz)
{
  HKEY hk;
  DWORD dp;

  if (RegCreateKeyEx(
      HKEY_CURRENT_USER,
      key,
      0,
      "REG_BINARY",
      REG_OPTION_NON_VOLATILE,
      KEY_WRITE,
      NULL,
      &hk,
      &dp)!=ERROR_SUCCESS)
    return;
  RegSetValueEx(hk,subkey,0,REG_BINARY,(BYTE*)value,sz);
  RegCloseKey(hk);
}

void WriteRegistryInteger(char *key,char *subkey,DWORD value)
{
  HKEY hk;
  DWORD dp;
  int sz;

  sz=sizeof(DWORD);
  if (RegCreateKeyEx(
      HKEY_CURRENT_USER,
      key,
      0,
      "REG_DWORD",
      REG_OPTION_NON_VOLATILE,
      KEY_WRITE,
      NULL,
      &hk,
      &dp)!=ERROR_SUCCESS)
    return;
  RegSetValueEx(hk,subkey,0,REG_DWORD,(BYTE*)&value,sz);
  RegCloseKey(hk);
}

BOOLEAN ReadRegistryString(char *key,char *subkey,char *value,int sz)
{
  HKEY  hk;
  DWORD type;

  if (RegOpenKeyEx(
      HKEY_CURRENT_USER,
      key,
      0,
      KEY_QUERY_VALUE,
      &hk)!=ERROR_SUCCESS)
    return FALSE;
  if (RegQueryValueEx(hk,subkey,0,&type,value,&sz)!=ERROR_SUCCESS)
  {
    RegCloseKey(hk);
    return FALSE;
  }
  RegCloseKey(hk);
  return TRUE;
}

BOOLEAN ReadRegistryInteger(char *key,char *subkey,DWORD *value)
{
  HKEY  hk;
  DWORD sz=sizeof(DWORD),type;

  if (RegOpenKeyEx(
      HKEY_CURRENT_USER,
      key,
      0,
      KEY_QUERY_VALUE,
      &hk)!=ERROR_SUCCESS)
    return FALSE;
  if (RegQueryValueEx(hk,subkey,0,&type,(LPBYTE)value,&sz)!=ERROR_SUCCESS)
  {
    RegCloseKey(hk);
    return FALSE;
  }
  RegCloseKey(hk);
  return TRUE;
}

