#include "jbsql.h"

HashTable g_ht;

#define LINESIZE 10000

void InsertReplacedLineBuffer(TextWidget *text,int newline,char *str)
{
  static char cmd[10*LINESIZE],*pos,*searchstr,replacestr[LINESIZE];
  int x,found=0;
  Keyword k;

  strcpy(cmd,str);
  if (INT_OPTION(SCAN))
  {
    searchstr=malloc(LINESIZE);
    for (;;)
    {
      pos=strstr(cmd,"&&");
      if (pos==NULL)
        break;
      found=1;
      searchstr[0]='\0';
      x=2;
      while (strchr(DELIMITERS,pos[x])==NULL)
      {
        searchstr[x-2]=pos[x];
        searchstr[x-1]='\0';
        x++;
      }
      if (strlen(searchstr)>0)
      {
        if (!HTGetRecord(vht,&searchstr,&k))
        {
          WPrintf("Enter value for %s: ",searchstr);
          WScanf(text,replacestr,0);
          k.keyword=strdup(searchstr);
          k.value=strdup(replacestr);
          HTAddRecord(vht,&k);
        }
        else
        {
          strcpy(replacestr,k.value);
        }
        free(k.keyword);
        free(k.value);
        memmove(&searchstr[2],searchstr,strlen(searchstr)+1);
        searchstr[0]='&';
        searchstr[1]='&';
        ReplaceString(pos,searchstr,replacestr);
      }
      else
      {
        memmove(pos,&pos[2],strlen(&pos[2])+1);
      }
    }
    for (;;)
    {
      pos=strstr(cmd,"&");
      if (pos==NULL)
        break;
      found=1;
      searchstr[0]='\0';
      x=1;
      while (strchr(DELIMITERS,pos[x])==NULL)
      {
        searchstr[x-1]=pos[x];
        searchstr[x]='\0';
        x++;
      }
      if (strlen(searchstr)>0)
      {
        if (!HTGetRecord(vht,&searchstr,&k))
        {
          WPrintf("Enter value for %s: ",searchstr);
          WScanf(text,replacestr,0);
        }
        else
        {
          strcpy(replacestr,k.value);
          free(k.keyword);
          free(k.value);
        }
        memmove(&searchstr[1],searchstr,strlen(searchstr)+1);
        searchstr[0]='&';
        ReplaceString(pos,searchstr,replacestr);
      }
      else
      {
        memmove(pos,&pos[1],strlen(&pos[1])+1);
      }
    }
    free(searchstr);
  }
  if (found && INT_OPTION(VERIFY))
  {
    WPrintf("old: %s\n",str);
    WPrintf("new: %s\n",cmd);
  }
  InsertUnparsedLineBuffer(text,cmd);
  if (newline)
    InsertNewLineBuffer(text);
}

void DefineArguments(char *str)
{
  char **argv=NULL,tmpstr[10];
  int argc,x;
  Keyword k;

  ConvertCommandLine(str,&argc,&argv);
  for (x=0;x<argc;x++)
  {
    sprintf(tmpstr,"%d",x+1);
    k.keyword=strdup(tmpstr);
    k.value=strdup(argv[x]);
    Trim(k.keyword);
    Trim(k.value);
    HTDeleteRecord(vht,&k.keyword);
    HTAddRecord(vht,&k);
    free(k.keyword);
    free(k.value);
    free(argv[x]);
  }
  if (argv)
    free(argv);
}

void CopyHashTable(Keyword *value)
{
  Keyword k;

  k.keyword=strdup(value->keyword);
  k.value=strdup(value->value);
  HTAddRecord(g_ht,&k);
  free(k.keyword);
  free(k.value);
}

int RunScript(ExecuteStruct *s)
{
  int do_cd=0;
  char pwd[MAX_PATH];
  char script_dir[MAX_PATH];
  char drive[_MAX_DRIVE];
  char dir[_MAX_DIR];
  char fname[_MAX_FNAME];
  char ext[_MAX_EXT];
  char filename[MAX_PATH];
  char str[LINESIZE+1];
  HANDLE f;
	DWORD bytes_read;
	int x,lastx=0,slen;
  char *script,*pos=NULL;
  HashTable tmp_ht;
  Option *options_old;

  script=strdup(command);
  if (script==NULL)
  {
    if (s->text->scripts==0)
  	  tid=0;
    return 0;
  }
  s->text->termout=0;
  strcpy(script,command);
  if (!s->text->scripts)
  {
    s->text->old_screen=s->INT_OPTION(SCREEN);
    s->INT_OPTION(SCREEN)=1;
  }
  ClearCommand(s->text,1,0);
  s->text->scripts++;
  Trim(script);
  *script=' ';
  Trim(script);
  GetCurrentDirectory(MAX_PATH,pwd);
  if (*script=='@')
  {
    *script=' ';
    Trim(script);
    if (s->text->dir[0]!='\0');
      SetCurrentDirectory(s->text->dir);
    do_cd=1;
  }
  strcpy(s->text->pwd,pwd);
  pos=script;
  if (*script=='"')
  {
    DeleteCharacterFromString(script,0);
    for (x=0;x<(int)strlen(script);x++)
    {
      if (script[x]=='"')
      {
        DeleteCharacterFromString(script,x);
        pos=&script[x];
        break;
      }
    }
  }
  tmp_ht=vht;
  vht=CreateVariableHashTable();
  g_ht=vht;
  HTForEach(tmp_ht,(HTForEachProc)CopyHashTable);
  for (;;)
  {
    pos=strchr(pos,' ');
    if (pos)
    {
      *pos='\0';
    }
    _splitpath( script, drive, dir, fname, ext );
    strcpy(s->text->dir,drive);
    strcat(s->text->dir,dir);
/*    SetCurrentDirectory(s->text->dir);
    GetCurrentDirectory(MAX_PATH,script_dir);
    SetCurrentDirectory(pwd);
    strcpy(s->text->dir,script_dir);*/
    strcpy(script_dir,s->text->dir);
    strcpy(filename,s->text->dir);
    //strcat(filename,"\\");
    strcat(filename,fname);
    if (ext[0]=='\0')
      strcat(filename,".sql");
    else
      strcat(filename,ext);
    f=CreateFile(filename,
               GENERIC_READ,
               FILE_SHARE_READ,
               NULL,
               OPEN_EXISTING,
               0,
               NULL);
             
    if (f==INVALID_HANDLE_VALUE)
    {
      if (pos==NULL)
      {
        WPrintf("Failed to open %s\n",filename);
        s->text->scripts--;
        if (s->text->scripts==0)
        {
  	      tid=0;
          s->text->termout=1;
          ShowPrompt(s->text);
        }
        s->INT_OPTION(SCREEN)=s->text->old_screen;
        HTDestroy(vht);
        vht=tmp_ht;
        return -1;
      }
      else
      {
        *pos=' ';
        pos++;
      }
    }
    else
    {
      if (pos)
        DefineArguments(pos+1);
      break;
    }
  }
  options_old=(Option*)malloc(noptions*sizeof(Option));
  CopyOptions(s->text->options,options_old);
  lastx=LINESIZE;
  str[0]='\0';
  for (;!s->text->cancelled;)
  {
    if (!ReadFile(f,&str[LINESIZE-lastx],lastx,&bytes_read,NULL) || bytes_read==0)
      break;
	  str[LINESIZE-lastx+bytes_read]='\0';
    slen=strlen(str);
    lastx=0;
    for (x=0;x<(int)slen && !s->text->cancelled;x++)
    {
      switch (str[x])
      {
        case '\r':
          str[x]=' ';
          break;
        case '\n':
          str[x]='\0';
          InsertReplacedLineBuffer(s->text,1,&str[lastx]);
          if (do_cd)
            SetCurrentDirectory(script_dir);
          strcpy(s->text->dir,script_dir);
          lastx=x+1;
          break;
        default:
          break;
      }
    }
    if (lastx<slen)
    {
      if (lastx==0)
      {
        InsertReplacedLineBuffer(s->text,0,&str[lastx]);
        if (do_cd)
          SetCurrentDirectory(script_dir);
        strcpy(s->text->dir,script_dir);
        lastx=LINESIZE;
        strcpy(str," ");
      }
      else
      {
        memmove(&str[0],&str[lastx],strlen(&str[lastx])+1);
      }
    }
    else
    {
      lastx=LINESIZE;
      strcpy(str," ");
    }
  }
  FreeOptions(s->text->options);
  free(s->text->options);
  s->text->options=(Option*)malloc(noptions*sizeof(Option));
  CopyOptions(options_old,s->text->options);
  FreeOptions(options_old);
  free(options_old);
  if (strlen(str) && str[strlen(str)-1]!='\n')
  {
    if (!s->text->cancelled)
    {
      InsertUnparsedLineBuffer(s->text,str);
      InsertNewLineBuffer(s->text);
      if (command[0]!='\0')
        InsertLineBuffer(s->text,"/\n",str);
    }
    if (command[0]!='\0')
    {
      WPrintf("\r");
      ClearCommand(s->text,0,0);
    }
    if (do_cd)
      SetCurrentDirectory(script_dir);
    strcpy(s->text->dir,script_dir);
  }

  SetCurrentDirectory(pwd);
	CloseHandle(f);
  free(script);
  s->text->scripts--;
  HTDestroy(vht);
  vht=tmp_ht;
  if (s->text->scripts==0)
  {
    s->text->termout=1;
    s->INT_OPTION(SCREEN)=s->text->old_screen;
    ShowPrompt(s->text);
  	tid=0;
    strcpy(s->text->dir,"");
    s->text->cancelled=0;
  }
  free(s->data);
  free(s);
  return 0;
}
