#include "jbsql.h"

#define SPLITTER_CLASS_NAME "SplitterClass"
int window_h_offset,window_v_offset;

void ResizeOtherWindows(void)
{
	RECT  sr;
	RECT  rc;
	RECT  sr2;
	RECT  tr;

	if (GetClientRect(g_hWnd, &rc)==0)
    return;
	if (GetWindowRect(hwndSplitter, &sr)==0)
    return;
	if (GetClientRect(hwndSplitter, &sr2)==0)
    return;
	if (GetWindowRect(g_toolbar, &tr)==0)
    return;

  Log("rc.right=%d, rc.left=%d, rc.bottom=%d, rc.top=%d",(int)rc.right,(int)rc.left,(int)rc.bottom,(int)rc.top);
  Log("sr.right=%d, sr.left=%d, sr.bottom=%d, sr.top=%d",(int)sr.right,(int)sr.left,(int)sr.bottom,(int)sr.top);
  Log("sr2.right=%d, sr2.left=%d, sr2.bottom=%d, sr2.top=%d",(int)sr2.right,(int)sr2.left,(int)sr2.bottom,(int)sr2.top);
  Log("tr.right=%d, tr.left=%d, tr.bottom=%d, tr.top=%d",(int)tr.right,(int)tr.left,(int)tr.bottom,(int)tr.top);
  MoveWindow( hwndTextBox, 
							0,            
							tr.bottom-tr.top,
							rc.right - rc.left,
							(rc.bottom-rc.top)-(sr.bottom - sr.top)+window_v_offset-(tr.bottom-tr.top),
							TRUE);
	MoveWindow( hwndListView, 
							0,            
							0,
							rc.right - rc.left,
							(sr2.bottom-sr2.top),
							TRUE);
  MoveWindow( g_toolbar,
              0,
              0,
              rc.right-rc.left,
              tr.bottom-tr.top,
              TRUE);
} 

void ResizeSplitter(HWND hwndSplitter, HWND hwndParent)
{
	RECT  rc;
	RECT  sr;

	GetClientRect(hwndParent, &rc);
	GetWindowRect(hwndSplitter, &sr);

	MoveWindow( hwndSplitter, 
							-window_h_offset,            // Don't show the left resize border
							(rc.bottom-rc.top)-(sr.bottom-sr.top)+window_v_offset, // Height of parent window - splitter height
							(rc.right - rc.left)+2*window_h_offset, // Don't show the right resize border
							sr.bottom - sr.top,     // Old height
							TRUE);
	ResizeOtherWindows();
}



LRESULT CALLBACK SplitterWndProc( HWND hWnd,
                              UINT uMessage,
                              WPARAM wParam,
                              LPARAM lParam)
{
	switch (uMessage)
	{
		case WM_CREATE:
			break;

		case WM_NOTIFY:
			return ListViewNotify(hWnd, lParam);
			break;

		case WM_SIZE:
  		ResizeOtherWindows();
			return 1;
			break;

		case WM_COMMAND:
      break;
		case WM_DESTROY:
			break;
    
		case WM_NCHITTEST:
			{
				LRESULT ret;

				ret=DefWindowProc(hWnd, uMessage, wParam, lParam);
				switch (ret)
				{
					case HTBORDER:
						return HTTOP;
				  case HTTOPLEFT:
            return HTTOP;
					case HTTOPRIGHT:
						return HTTOP;
					case HTBOTTOMRIGHT:
					case HTBOTTOMLEFT:
					case HTBOTTOM:
					case HTGROWBOX:
					case HTLEFT:
					case HTRIGHT:
						return HTBORDER;
					default:
						return ret;
				}
			}
			break;
    case WM_CONTEXTMENU:
      {
        TextWidget *text;
        HMENU m1,m2;

        if (f) /* There's something in the listview */
        {
          text=(TextWidget*)GetWindowLong(hwndTextBox, 0);
          m1=GetMenu(hwndListView);
          m2=GetSubMenu(m1,0);
          switch (TrackPopupMenu(GetSubMenu(g_menu,0),
                                 TPM_LEFTALIGN|TPM_TOPALIGN|TPM_RETURNCMD|TPM_RIGHTBUTTON,
                                 LOWORD(lParam),
                                 HIWORD(lParam),
                                 0,
                                 hWnd,
                                 NULL))
          {          
            case ID_COPY_COPYFIRSTCOLUMN:
              CopyFromListView(hwndListView,0);
              break;
            case ID_COPY_COPYENTIRELINE:
              CopyFromListView(hwndListView,1);
              break;
          }
        }
        break;
      }
		default:
			break;
		}
	return DefWindowProc(hWnd, uMessage, wParam, lParam);
}

HWND CreateSplitter(HINSTANCE hInstance, HWND hwndParent)
{
	DWORD       dwStyle;
	HWND        hwndSplitter;
	BOOL        bSuccess = TRUE;
	WNDCLASSEX  wcex;
	ATOM        aReturn;

	wcex.cbSize          = sizeof(WNDCLASSEX);
	wcex.style           = 0;
	wcex.lpfnWndProc     = (WNDPROC)SplitterWndProc;
	wcex.cbClsExtra      = 0;
	wcex.cbWndExtra      = 0;
	wcex.hInstance       = hInstance;
	wcex.hCursor         = LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground   = NULL;
	wcex.lpszMenuName    = NULL;
	wcex.lpszClassName   = SPLITTER_CLASS_NAME;
	wcex.hIcon           = NULL;
	wcex.hIconSm         = NULL;

	window_h_offset=GetSystemMetrics(SM_CXSIZEFRAME);
	window_v_offset=GetSystemMetrics(SM_CYSIZEFRAME);
	aReturn = RegisterClassEx(&wcex);

	dwStyle =   WS_CHILD | 
							WS_VISIBLE |
							WS_DLGFRAME;
	
	hwndSplitter = CreateWindowEx(   WS_EX_WINDOWEDGE,                         // ex style
																	 SPLITTER_CLASS_NAME,       // class name - defined in commctrl.h
																	 "",                        // dummy text
																	 dwStyle,                   // style
																	 0,                         // x position
																	 0,                         // y position
																	 0,                         // width
																	 198,                       // height
																	 hwndParent,                // parent
																	 (HMENU)ID_SPLITTER,        // ID
																	 g_hInst,                   // instance
																	 NULL);                     // no extra data
	if(!hwndSplitter)
	  return NULL;

	ResizeSplitter(hwndSplitter, hwndParent);
//  SetWindowRgn(hwndSplitter,NULL,TRUE);
  return hwndSplitter;
}

