#include "jbsql.h"

HWND g_toolbar=(HWND)0;
HIMAGELIST imagelist;

HWND BuildToolbar(TextWidget *text,HINSTANCE hInst,HWND hWnd)
{
  HWND toolbar;
  TBBUTTON buttons[30];
  int x,nbuttons=0,nbitmaps=0;
  HICON hicon;

  if (g_toolbar)
  {
    ImageList_Destroy(imagelist);
    DestroyWindow(g_toolbar);
  }
    
  imagelist=ImageList_Create(16,16,TRUE,30,1);
  hicon = LoadIcon(hInst, MAKEINTRESOURCE(IDI_CONNECT)); 
  ImageList_AddIcon(imagelist, hicon); 
  nbitmaps++;

  hicon = LoadIcon(hInst, MAKEINTRESOURCE(IDI_NEWWINDOW)); 
  ImageList_AddIcon(imagelist, hicon); 
  nbitmaps++;
 
  hicon = LoadIcon(hInst, MAKEINTRESOURCE(IDI_COMMIT)); 
  ImageList_AddIcon(imagelist, hicon); 
  nbitmaps++;
 
  hicon = LoadIcon(hInst, MAKEINTRESOURCE(IDI_ROLLBACK)); 
  ImageList_AddIcon(imagelist, hicon); 
  nbitmaps++;
 
  hicon = LoadIcon(hInst, MAKEINTRESOURCE(IDI_CANCEL)); 
  ImageList_AddIcon(imagelist, hicon); 
  nbitmaps++;
 
  hicon = LoadIcon(hInst, MAKEINTRESOURCE(IDI_REPEAT)); 
  ImageList_AddIcon(imagelist, hicon); 
  nbitmaps++;
 
  buttons[nbuttons].iBitmap=0;
  buttons[nbuttons].idCommand=ID_FILE_CONNECT;
  buttons[nbuttons].fsState=TBSTATE_ENABLED;
  buttons[nbuttons].fsStyle=TBSTYLE_BUTTON;
  buttons[nbuttons].dwData=0;
  buttons[nbuttons].iString=0;
  nbuttons++;

  buttons[nbuttons].iBitmap=1;
  buttons[nbuttons].idCommand=ID_NEW_WINDOW;
  buttons[nbuttons].fsState=TBSTATE_ENABLED;
  buttons[nbuttons].fsStyle=TBSTYLE_BUTTON;
  buttons[nbuttons].dwData=0;
  buttons[nbuttons].iString=0;
  nbuttons++;

  buttons[nbuttons].iBitmap=0;
  buttons[nbuttons].idCommand=0;
  buttons[nbuttons].fsState=TBSTATE_ENABLED;
  buttons[nbuttons].fsStyle=TBSTYLE_SEP;
  buttons[nbuttons].dwData=0;
  buttons[nbuttons].iString=0;
  nbuttons++;

  buttons[nbuttons].iBitmap=2;
  buttons[nbuttons].idCommand=ID_COMMIT;
  buttons[nbuttons].fsState=TBSTATE_ENABLED;
  buttons[nbuttons].fsStyle=TBSTYLE_BUTTON;
  buttons[nbuttons].dwData=0;
  buttons[nbuttons].iString=0;
  nbuttons++;

  buttons[nbuttons].iBitmap=3;
  buttons[nbuttons].idCommand=ID_ROLLBACK;
  buttons[nbuttons].fsState=TBSTATE_ENABLED;
  buttons[nbuttons].fsStyle=TBSTYLE_BUTTON;
  buttons[nbuttons].dwData=0;
  buttons[nbuttons].iString=0;
  nbuttons++;

  buttons[nbuttons].iBitmap=4;
  buttons[nbuttons].idCommand=ID_QUERY_CANCEL;
  buttons[nbuttons].fsState=TBSTATE_ENABLED;
  buttons[nbuttons].fsStyle=TBSTYLE_BUTTON;
  buttons[nbuttons].dwData=0;
  buttons[nbuttons].iString=0;
  nbuttons++;

  buttons[nbuttons].iBitmap=5;
  buttons[nbuttons].idCommand=ID_REPEAT;
  buttons[nbuttons].fsState=TBSTATE_ENABLED;
  buttons[nbuttons].fsStyle=TBSTYLE_BUTTON;
  buttons[nbuttons].dwData=0;
  buttons[nbuttons].iString=0;
  nbuttons++;

  buttons[nbuttons].iBitmap=0;
  buttons[nbuttons].idCommand=0;
  buttons[nbuttons].fsState=TBSTATE_ENABLED;
  buttons[nbuttons].fsStyle=TBSTYLE_SEP;
  buttons[nbuttons].dwData=0;
  buttons[nbuttons].iString=0;
  nbuttons++;

  for (x=0;x<noptions;x++)
  {
    if (text->options[x].on_toolbar)
    {
      hicon = LoadIcon(hInst, MAKEINTRESOURCE(text->options[x].icon)); 
      ImageList_AddIcon(imagelist, hicon); 

      buttons[nbuttons].iBitmap=nbitmaps;
      buttons[nbuttons].idCommand=UM_TOOLTIP+x;
      buttons[nbuttons].fsState=(text->options[x].value.int_value)?(TBSTATE_ENABLED|TBSTATE_CHECKED):(TBSTATE_ENABLED);
      buttons[nbuttons].fsStyle=TBSTYLE_CHECK;
      buttons[nbuttons].dwData=x;
      buttons[nbuttons].iString=0;
      nbuttons++;
      nbitmaps++;
    }
  }

  toolbar = CreateWindowEx(0, 
                           TOOLBARCLASSNAME, 
                           (LPSTR) NULL, 
                           WS_CHILD | TBSTYLE_TOOLTIPS , 
                           0, 
                           0, 
                           0, 
                           0, 
                           hWnd, 
                           (HMENU) ID_TOOLBAR, 
                           hInst, 
                           NULL);
  if (toolbar==NULL)
  {
    DisplayLastError(hWnd);
    return NULL;
  }
  SendMessage(toolbar,TB_SETIMAGELIST,0,(LPARAM)imagelist);
  SendMessage(toolbar,TB_BUTTONSTRUCTSIZE,sizeof(TBBUTTON),0);
  SendMessage(toolbar,TB_ADDBUTTONS,nbuttons,(LPARAM)buttons);
  SendMessage(toolbar,TB_SETINDENT,2,(LPARAM)0);
  SendMessage(toolbar,TB_AUTOSIZE,0,0);
  ShowWindow(toolbar,SW_SHOW);
  g_toolbar=toolbar;
  return toolbar;
}